=== debian/changelog ===
onevpl-intel-gpu (24.3.4-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 25 Sep 2024 11:19:32 +0300

onevpl-intel-gpu (24.3.3-1) unstable; urgency=medium

  * New upstream release.
  * control: Migrate to pkgconf.
  * control: Update descriptions.
  * copyright, watch: Update for the upstream rebranding.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 13 Sep 2024 10:05:00 +0300
