## onevpl-intel-gpu 25.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -27,14 +27,8 @@
 
 
 # Througout this project MFX_VERSION refers to uAPI version and MEDIA_VERSION refers to product version
-set(MEDIA_VERSION 24.3.4) # auto-update
+set(MEDIA_VERSION 25.1.2) # auto-update
 set(MEDIA_VERSION_STR "${MEDIA_VERSION}${MEDIA_VERSION_EXTRA}" CACHE STRING "" FORCE)
-
-if(CMAKE_SYSTEM_NAME MATCHES WindowsStore)
-  if(NOT VS_WINDOWS_TARGET_PLATFORM_MIN_VERSION)
-    set(VS_WINDOWS_TARGET_PLATFORM_MIN_VERSION $ENV{MINIDDK_VERSION})
-  endif()
-endif()
 
 set(LANG CXX C ASM)
 project(mfxgen1
