=== debian/changelog ===
onevpl-intel-gpu (25.1.2-1ubuntu2) plucky; urgency=medium

  * Backport patch to add Battlemage PCI ID 0xE211 (LP: #2106038) 

 -- Shane McKee <shane.mckee@canonical.com>  Thu, 03 Apr 2025 17:55:05 +0400

onevpl-intel-gpu (25.1.2-1ubuntu1) plucky; urgency=medium

  * Backport patches to add BMG PCI IDS (LP: #2104011) 

 -- Shane McKee <shane.mckee@canonical.com>  Tue, 25 Mar 2025 23:59:35 +0800

onevpl-intel-gpu (25.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 27 Feb 2025 08:58:17 +0200
